#
#
#
"""


"""
__author__  = 'JoseSantos <jms@fct.unl.pt>'
__docformat__ = 'restructuredtext'

import time

try:
    from Products.LinguaPlone.public import *
except ImportError:
    # No multilingual support
    from Products.Archetypes.public import *

from Products.CMFCore.permissions import View
from Products.CMFCore.permissions import ModifyPortalContent
from AccessControl import ClassSecurityInfo
from Products.CMFCore.utils import getToolByName

#from Products.Archetypes.public import Schema
#from Products.Archetypes.public import StringField
#from Products.Archetypes.public import StringWidget
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import *

#from Products.ATContentTypes.config import PROJECTNAME
#from Products.ATContentTypes.config import HAS_PLONE2
#from Products.ATContentTypes.content.base import registerATCT
from Products.ATContentTypes.content.base import ATCTContent
#from Products.ATContentTypes.interfaces import IATLink
from Products.ATContentTypes.content.schemata import ATContentTypeSchema
#from Products.ATContentTypes.content.schemata import finalizeATCTSchema

from Products.ATContentTypes.content.folder import *

from Products.SMenu.config import *

SMenuSchema = ATFolderSchema.copy() + Schema((
    StringField('CSSId',
                required      = False,
                multiValued   = False,
                show_indexes  = False,
                searchable    = False,
                default       = "",
                widget = StringWidget(default_search_index = 'SearchableText',
                                      maxlength            = 255,
                                      description          = 'CSS Id of this menu',
                                      description_msgid    = "css_id_help",
                                      label                = "CSS Id",
                                      label_msgid          = "css_id",
                                      i18n_domain          = "smenu",
                                     )
               ),
))



SMenuItemSchema = ATFolderSchema.copy() + Schema((
    ReferenceField('referenceLink',
                   required          = False,
                   multiValued       = False,
                   show_indexes      = False,
                   allow_search      = False,
#                   allowed_types     = ('Document','File','Image', 'Folder', 'SLink', ''),
# FALTA: FormMailler
                   startup_directory = '/',
                   relationship      = 'LinkRel',
                   widget = ReferenceBrowserWidget(default_search_index = 'SearchableText',
                                                   description       = 'pick an object to make a link to.',
                                                   description_msgid = "object_to_link_help",
                                                   label       = "Object to link",
                                                   label_msgid = "object_to_link",
                                                   i18n_domain = "smenu",
                                                  )
                  ),
    StringField('URI',
                required      = False,
                multiValued   = False,
                show_indexes  = False,
                searchable    = False,
                default       = "http://",
                widget = StringWidget(default_search_index = 'SearchableText',
                                      maxlength            = 255,
                                      description          = 'enter the url (web address) to make a link to.',
                                      description_msgid    = "url_help",
                                      label                = "URL",
                                      label_msgid          = "url",
                                      i18n_domain          = "smenu",
                                     )
               ),
    BooleanField('autoExpand',
                 required=1,
                 mode="rw",
                 #                  write_permission=ChangeTopics,
                 default=False,
                 widget=BooleanWidget(
                                      visible=1,
                                      label="autoExpand",
                                      label_msgid="label_boolean_exapand",
                                      description="Allways expand sub-items.",
                                      description_msgid="help_boolean_auto_expand",
                                      i18n_domain="smenu"),
                 ),
    BooleanField('expand',
                 required=1,
                 mode="rw",
                 #                  write_permission=ChangeTopics,
                 default=True,
                 widget=BooleanWidget(
                                      visible=1,
                                      label="Expand",
                                      label_msgid="label_boolean_auto_exapand",
                                      description="Expand sub-menu, if selected.",
                                      description_msgid="help_boolean_auto_expand",
                                      i18n_domain="smenu"),
                 ),
    BooleanField('not_show_selected',
                 required=1,
                 mode="rw",
                 #                  write_permission=ChangeTopics,
                 default=False,
                 widget=BooleanWidget(
                                      visible=1,
                                      label="Do not show if selected",
                                      label_msgid="label_boolean_not_show_selected",
                                      description="If item is selected, will not be seen. Use to not show first item (main page).",
                                      description_msgid="help_boolean_not_show_selected",
                                      i18n_domain="smenu"),
                 ),
))


class SMenu(ATFolder):
    """A simple, static menu."""

    def time(self):
        return time.time()

    def iconizePath(self, parentpath, item):
        path = item.getPath()
        size = len(parentpath)
        result={}
        # This deserves an explanation ;)
        # Returns something like ['item1','subitem3'], based on the object (relative) path
        result['path'] = path[size:].split("/")[1:]
        result['object'] = item
        return result

    def makesubtree(self, parenticon, icon_dict, depth):
        subtree = []
        if not icon_dict.has_key(depth):
            return []
        parenticon_len = len(parenticon)
        for icon in icon_dict[depth]:
            if parenticon == icon['path'][:parenticon_len]:
                subsubtree = self.makesubtree(icon['path'], icon_dict, depth + 1)
                subtree_item = {}
                subtree_item['name'] = icon['path'][-1]
                subtree_item['object'] = icon['object']
                subtree_item['subtree'] = subsubtree            
                subtree += [subtree_item]        
        return subtree

    def maketree(self, iconlist):
        icon_dict = {}
        icon_dict[1]=[]
        # list, by depth (needed aux)
        for icon in iconlist:
            icon_len = len(icon['path'])
            if not icon_dict.has_key(icon_len):
                icon_dict[icon_len] = []
            icon_dict[icon_len] += [icon]
        # Create the tree 
        tree = []
        for icon in icon_dict[1]:
            subtree = self.makesubtree(icon['path'], icon_dict, 2)
            tree_item = {}
            tree_item['name'] = icon['path'][0]
            tree_item['object'] = icon['object']
            tree_item['subtree'] = subtree            
            tree += [tree_item]
        return tree

    def physicalPath(self):
        physical_path = self.getPhysicalPath()
        path = ''.join(['/'+i for i in physical_path[1:]])
        return path

    def getFlatList(self):
        portal_catalog = getToolByName(self, 'portal_catalog')
        path = self.physicalPath()
#        path=self.absolute_url_path()
        restrictions = { 'portal_type': 'SMenuItem',
                         'sort_on':'getObjPositionInParent',
                         'path': {'query': [path], 'depth': -1},
                       }
        flatlist = apply(portal_catalog.searchResults, (), restrictions)
        return flatlist

    def getTree(self):
        path = self.physicalPath()
#        path=self.absolute_url_path()
        flatlist = self.getFlatList()
        iconslist = [self.iconizePath(path, i) for i in flatlist]
        treelist = self.maketree(iconslist)
        return treelist
#        return self.listFolderContents(contentFilter={'portal_type' : ['SMenuItem']})

    schema         =  SMenuSchema

#    content_icon   = 'link_icon.gif'
    meta_type      = 'SMenu'
    portal_type    = 'SMenu'
    archetype_name = 'SMenu'
#    immediate_view = 'SMenu_view'
#    default_view   = 'SMenu_view'
#    suppl_views    = ()
    typeDescription= 'A Simple (Static) menu.'
    typeDescMsgId  = 'description_edit_smenu'
#    assocMimetypes = ()
    filter_content_types = 1
    allowed_content_types = ('SMenuItem',)

    
#    assocFileExt   = ('link', 'url', )
#    cmf_edit_kws   = ('remote_url', )

#    __implements__ = ATCTContent.__implements__
#    __implements__ = ATCTContent.__implements__, IATLink

    security       = ClassSecurityInfo()
#    invokeFactory(id='folder1', type_name='Folder')
#    action(id='document_view', title='document_view')

registerType(SMenu)


class SMenuItem(ATFolder):
    """A simple, static menu item."""

    def getReferenceUID(self):
        if self.getField('referenceLink'):
            return self.getField('referenceLink').getRaw(self)
        else:
            return False        

    schema         =  SMenuItemSchema

    meta_type      = 'SMenuItem'
    portal_type    = 'SMenuItem'
    archetype_name = 'SMenuItem'
    typeDescription= 'Menu item.'
    typeDescMsgId  = 'description_edit_smenu_item'
    filter_content_types = 1
    allowed_content_types = ('SMenuItem',)
    global_allow = False
    
    security       = ClassSecurityInfo()

registerType(SMenuItem)
