## Script (Python) "makeMenu"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##parameters= tree, flatList, current_path, current_obj, themenu,
##title=
##

# FIXME: there are lines commented out while in the optimization process.

from Products.CMFCore.utils import getToolByName
from Products.CMFCore.permissions import View

portal_url = container.portal_url()

#######################################################
# get_all_parents_uids
#######################################################
def get_all_parents(current_obj):
    list = [current_obj]
    obj = current_obj
    while hasattr(obj, "aq_inner") and hasattr(obj.aq_inner, "aq_parent"):
        obj = obj.aq_inner.aq_parent
        if hasattr(obj, "getDefaultPage") and hasattr(obj, obj.getDefaultPage()):
            obj_default_page = getattr(obj, obj.getDefaultPage())
            list += [obj_default_page]
        if hasattr(obj, 'UID'):
            list += [obj]
    return list

#######################################################
# getPrintTree
#######################################################
def current_selected():
    parents = get_all_parents(current_obj)

    for parent in parents:
        if hasattr(parent, 'UID'):
            parent_uid = parent.UID()
            for item in flatList:
                if get_reference_uid(item) == parent_uid:
                    return parent_uid
    return 0

def get_reference_uid(item):
    # Could make some checks, but this way is faster !
    try:
        return item.getReferenceLink.UID()
    except:
        pass
    return 0

def get_not_show_selected(item):
    try:
        return item.getNot_show_selected
    except:
        pass
    return False

def get_URI(item):
    try:
        uri = item.getURI
        if uri == 'http://':
            return ''
        return uri
    except:
        pass
    return ''

def get_auto_expand(item):
    try:
        return item.getAutoExpand
    except:
        pass
    return False

def get_expand(item):
    try:
        return item.getExpand
    except:
        pass
    return True

def is_selected(item, selected_uid):
#    if selected_uid and get_reference_uid(item) == selected_uid and get_expand(item):
    if get_reference_uid(item) == selected_uid and get_expand(item):
        return True
    return False

def getSubTree(parent, tree, selected_uid):
    result_tree=[]
    found_selected = False
    
    for i in tree:
        new_i={}
        new_i['reference_uid'] = get_reference_uid(i['object'])
        if not(get_not_show_selected(i['object']) and new_i['reference_uid'] == selected_uid == current_obj_uid):
            new_i['uri'] = get_URI(i['object'])
            if not new_i['uri'] and new_i['reference_uid']:
                new_i['uri'] = portal_url + '/resolveUid/' + new_i['reference_uid']
            new_i['name'] = i['name']
            new_i['object'] = i['object']
            if get_auto_expand(i['object']) and is_selected(parent, selected_uid):
                # I Auto Expand and my parent is selected ? 
                new_i['subtree']=getSubTree(i['object'], i['subtree'], get_reference_uid(i['object']))
            else:
                new_i['subtree']=getSubTree(i['object'], i['subtree'], selected_uid)
            result_tree.append(new_i)
            # Is there a child to open ? print me
            if new_i['subtree']:
                found_selected = True
                # No child and I'm the one selected ? print me
            if i['subtree']==[] and is_selected(i['object'], selected_uid):
                found_selected = True
    # Was my parent the selected ? print me
    if (not found_selected) and is_selected(parent, selected_uid):
        found_selected = True
    if found_selected:
        return result_tree
    return []


def getPrintTree(tree, selected_uid):
    result_tree=[]
    for i in tree:
        new_i={}
        new_i['reference_uid'] = get_reference_uid(i['object'])
        if not(get_not_show_selected(i['object']) and new_i['reference_uid'] == selected_uid == current_obj_uid):
            new_i['uri'] = get_URI(i['object'])
            if not new_i['uri'] and new_i['reference_uid']:
                new_i['uri'] = portal_url + '/resolveUid/' + new_i['reference_uid']
            new_i['name'] = i['name']
            new_i['object'] = i['object']

            if get_auto_expand(i['object']):
                # Auto Expand ? 
                new_i['subtree']=getSubTree(i['object'], i['subtree'], get_reference_uid(i['object']))
            else:
                new_i['subtree']=getSubTree(i['object'], i['subtree'], selected_uid)
#            new_i['subtree']=getSubTree(i['object'], i['subtree'], selected_uid)

            result_tree.append(new_i)        
    return result_tree


def getUID(current_obj):
    if hasattr(current_obj, 'UID'):
        return current_obj.UID()
    return 0


#######################################################
# getOpenedList
#######################################################

def getOpenedList(selected_uid, print_tree):
    result = []
    for i in print_tree:
        i_uid = i['reference_uid']
        subtree = getOpenedList(selected_uid, i['subtree'])
        if i_uid == selected_uid:
            result += [selected_uid]
        if subtree:
            result += [i_uid] + subtree
    return result
    


#######################################################
# MAIN
#######################################################

current_obj_uid = getUID(current_obj)
selected_uid = current_selected()
print_tree = getPrintTree(tree, selected_uid)
opened_list = getOpenedList(selected_uid, print_tree)

return (selected_uid, opened_list, print_tree)

